<template>
  <div class="container-main" ref="main">
    <div class="search-hearder" ref="topSearch">
      <el-form
        :model="queryParams"
        ref="queryForm"
        :inline="true"
        v-show="showSearch"
        label-width="auto"
      >
        <!-- <el-form-item label="区域" prop="areaId">
          <el-select
            v-model="queryParams.areaId"
            placeholder="请选择区域"
            clearable
            size="small"
          >
            <el-option
              v-for="dict in dict.type.tc_area"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"
            />
          </el-select>
        </el-form-item> -->
        <el-form-item label="启用/禁用" prop="isStatus">
          <el-select
            v-model="queryParams.isStatus"
            placeholder="请选择启用/禁用"
            clearable
            size="small"
          >
            <el-option
              v-for="dict in dict.type.tc_start"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="单位名称" prop="unitName">
          <el-input
            v-model="queryParams.unitName"
            placeholder="请输入单位名称"
            clearable
            size="small"
            @keyup.enter.native="handleQuery"
          />
        </el-form-item>
        <el-form-item label="目标IP/域名" prop="ipAddress">
          <el-input
            v-model="queryParams.ipAddress"
            placeholder="请输入目标IP/域名"
            clearable
            size="small"
            @keyup.enter.native="handleQuery"
          />
        </el-form-item>

        <el-form-item>
          <el-button
            type="primary"
            icon="el-icon-search"
            size="mini"
            @click="handleQuery"
            >搜索</el-button
          >
          <el-button icon="el-icon-refresh" size="mini" @click="resetQuery"
            >重置</el-button
          >
        </el-form-item>
      </el-form>
    </div>
    <div class="layui-table-tool" ref="tableTool">
      <el-button
        type="primary"
        size="mini"
        @click="handleAdd()"
        v-hasPermi="['tcZz/networkSecurity:tbcz:add']"
        >新增</el-button
      >
      <el-button
        type="success"
        size="mini"
        :disabled="single"
        @click="handleUpdate"
        v-hasPermi="['tcZz/networkSecurity:tbcz:edit']"
        >修改</el-button
      >
      <el-button
        type="danger"
        size="mini"
        :disabled="multiple"
        @click="handleDelete"
        v-hasPermi="['tcZz/networkSecurity:tbcz:remove']"
        >删除</el-button
      >
      <el-button
        type="warning"
        size="mini"
        :loading="exportLoading"
        @click="handleExport"
        v-hasPermi="['tcZz/networkSecurity:tbcz:export']"
        >导出</el-button
      >
      <el-button type="primary" size="mini" @click="importFiles"
        >导入</el-button
      >
      <el-button type="success" size="mini" @click="enable" :disabled="multiple"
        >启用</el-button
      >
      <el-button
        type="danger"
        size="mini"
        @click="banned"
        autofocus
        :disabled="multiple"
        >禁用</el-button
      >
    </div>
    <el-table
      v-loading="loading"
      :data="tbczList"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55" align="center" />
      <!-- <el-table-column label="区域" align="center" prop="areaId">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.tc_area" :value="scope.row.areaId" />
        </template>
      </el-table-column> -->

      <el-table-column label="单位名称" align="center" prop="unitName" />
      <el-table-column label="目标IP/域名" align="center" prop="ipAddress" />
      <el-table-column label="处置情况" align="center" prop="czState" />
      <el-table-column label="启用/禁用" align="center" prop="isStatus">
        <template slot-scope="scope">
          <el-switch
            v-model="scope.row.isStatus"
            active-color="#ff4949"
            inactive-color="#13ce66"
            :active-value="2"
            :inactive-value="1"
            @change="alter(scope.row)"
          >
          </el-switch>
          <!-- <dict-tag :options="dict.type.tc_start" :value="scope.row.isStatus" /> -->
        </template>
      </el-table-column>
      <el-table-column
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
        width="200"
        fixed="right"
      >
        <template slot-scope="scope">
          <el-button
            size="mini"
            @click="handleInfo(scope.row)"
            v-hasPermi="['tcZz/networkSecurity:tbcz:list']"
          >
            查看
          </el-button>
          <el-button
            type="success"
            size="mini"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['tcZz/networkSecurity:tbcz:edit']"
            >修改</el-button
          >
          <el-button
            size="mini"
            type="danger"
            @click="handleDelete(scope.row)"
            v-hasPermi="['tcZz/networkSecurity:tbcz:remove']"
            >删除</el-button
          >
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改通报处置对话框 -->
    <el-dialog
      :visible.sync="open"
      width="500px"
      append-to-body
      custom-class="dialog-box"
    >
      <div slot="title" class="dialog-title">{{ title }}</div>
      <el-form
        ref="form"
        :model="form"
        :rules="rules"
        label-width="auto"
        class="dialog-from"
      >
        <!-- <el-form-item label="区域" prop="areaId">
          <el-select v-model="form.areaId" placeholder="请选择区域">
            <el-option
              v-for="dict in dict.type.tc_area"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"
            ></el-option>
          </el-select>
        </el-form-item> -->
        <el-form-item label="启用/禁用" prop="isStatus">
          <el-radio-group v-model="form.isStatus">
            <el-radio :label="1">启用</el-radio>
            <el-radio :label="2">禁用</el-radio>
          </el-radio-group>
        </el-form-item>
        <el-form-item label="上传文件">
          <div class="updataFile">
            <div class="fileHeader">
              <div class="names">文件名称</div>
              <div class="urls">文件路径(完整路径)</div>
            </div>
            <div @click="addFile" class="fileIcon">
              <i class="el-icon-circle-plus-outline"></i>
            </div>
          </div>
          <div
            class="main-file"
            v-for="(item, index) in fileNameS"
            :key="index"
          >
            <div class="fileItems">
              <div class="names">
                <el-input
                  v-model="item.fileName"
                  placeholder="请输入文件名称"
                />
              </div>
              <div class="urls">
                <el-input
                  v-model="item.fileUrl"
                  placeholder="请输入文件路径(完整路径)"
                />
              </div>
            </div>
            <div @click="removeFile(index)" class="fileIcon">
              <i class="el-icon-remove-outline"></i>
            </div>
          </div>
        </el-form-item>
        <el-form-item label="单位名称" prop="unitName">
          <el-input v-model="form.unitName" placeholder="请输入单位名称" />
        </el-form-item>
        <el-form-item label="目标IP/域名" prop="ipAddress">
          <el-input v-model="form.ipAddress" placeholder="请输入目标IP/域名" />
        </el-form-item>
        <el-form-item label="处置情况" prop="czState">
          <el-input v-model="form.czState" placeholder="请输入处置情况" />
        </el-form-item>

        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <!--查看通报处置详情页-->
    <el-dialog
      :visible.sync="infoOpen"
      width="90%"
      append-to-body
      :close-on-click-modal="false"
      :destroy-on-close="true"
      custom-class="dialog-box"
    >
      <div slot="title" class="dialog-title">{{ infoTitle }}</div>

      <el-descriptions
        title="通报处置"
        :column="2"
        border
        labelClassName="desLable"
      >
        <!-- <el-descriptions-item label="区域">{{
          selectDictLabel(dict.type.tc_area, form.areaId)
        }}</el-descriptions-item> -->

        <el-descriptions-item label="启用/禁用">{{
          selectDictLabel(dict.type.tc_start, form.isStatus)
        }}</el-descriptions-item>

        <el-descriptions-item label="单位名称">{{
          form.unitName
        }}</el-descriptions-item>

        <el-descriptions-item label="目标IP/域名">{{
          form.ipAddress
        }}</el-descriptions-item>

        <el-descriptions-item label="处置情况">{{
          form.czState
        }}</el-descriptions-item>

        <el-descriptions-item label="文件名称">{{
          form.fileName
        }}</el-descriptions-item>

        <el-descriptions-item label="文件路径(完整路径)">
          <a
            style="text-decoration: underline; color: rgb(24, 144, 255)"
            v-for="(item, index) in files(form.fileUrl)"
            target="_blank"
            :key="index"
            :href="item"
            >{{ item }}&nbsp;,&nbsp;</a
          >
          </el-descriptions-item
        >

        <el-descriptions-item label="备注">{{
          form.remark
        }}</el-descriptions-item>
      </el-descriptions>
    </el-dialog>
    <!-- 导入 -->
    <el-dialog
      :visible.sync="fileOpen"
      width="400px"
      append-to-body
      custom-class="dialog-box"
      @close="cancelFile"
    >
      <div slot="title" class="dialog-title">导入</div>
      <el-upload
        ref="upload"
        :limit="limit"
        action="666"
        :accept="accept"
        :headers="headers"
        :file-list="fileList"
        :multiple="false"
        :auto-upload="false"
        drag
        :before-upload="handleBeforeUpload"
        :on-exceed="handleExceed"
        :http-request="handleFile"
      >
        <i class="el-icon-upload"></i>
        <div class="el-upload__text">将文件拖到此处，或<em>点击上传</em></div>
        <div class="el-upload__tip text-center" slot="tip">
          <span>仅允许导入xls、xlsx格式文件。</span>
          <el-link
            type="primary"
            :underline="false"
            style="font-size: 12px; vertical-align: baseline"
            @click="importTemplate"
            >下载模板</el-link
          >
        </div>
      </el-upload>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitFile">确 定</el-button>
        <el-button @click="cancelFile">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listTbcz,
  getTbcz,
  delTbcz,
  addTbcz,
  updateTbcz,
  exportTbcz,
  isStatusTbcz,
  importTbcz,
} from "@/api/tcZz/networkSecurity/tbcz";
import { getToken } from "@/utils/auth";
export default {
  name: "Tbcz",
  //注释字典
  dicts: ["tc_area", "tc_start"],
  data() {
    return {
      tableHeigth: 0,
      //查看详情
      infoOpen: false,
      //详情标题
      infoTitle: "",
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 通报处置表格数据
      tbczList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 备注时间范围
      daterangeCreateTime: [],
      // 备注时间范围
      daterangeUpdateTime: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        id: null,

        // areaId: null,

        isStatus: null,

        unitName: null,

        ipAddress: null,

        czState: null,

        fileName: null,

        fileUrl: null,

        createBy: null,

        createTime: null,

        updateBy: null,

        updateTime: null,

        remark: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        // areaId: [{ required: true, message: "请选择区域", trigger: "blur" }],
        isStatus: [
          { required: true, message: "请选择启动/禁用", trigger: "blur" },
        ],
        unitName: [
          { required: true, message: "单位名称不能为空", trigger: "blur" },
        ],
        ipAddress: [
          { required: true, message: "目标IP/域名不能为空", trigger: "blur" },
        ],
        czState: [
          { required: true, message: "处置情况不能为空", trigger: "blur" },
        ],
      },
      fileNameS: [],
      //===========
      fileList: [],
      limit: 1,
      accept: ".xls,.xlsx",
      fileOpen: false,
      headers: { Authorization: "Bearer " + getToken() },
    };
  },
  created() {
    this.getList();
  },
  methods: {
    files(e) {
      if (!e) return [];
      return e.split(",");
    },
    alter(e) {
      updateTbcz(e).then(() => {
        this.getList();
        this.$modal.msgSuccess("修改成功");
      });
    },
    //下载模板
    importTemplate() {
      this.download(
        "/tcZz/networkSecurity/tbcz/importTemplate",
        {},
        `通报处置模板.xlsx`
      );
    },
    //导入
    importFiles() {
      this.fileOpen = true;
    },
    submitFile() {
      this.$refs.upload.submit();
    },
    cancelFile() {
      this.fileOpen = false;
    },
    //导入
    handleBeforeUpload(file) {
      // 校检文件类型
      const fileName = file.name.split(".");
      const fileExt = fileName[fileName.length - 1];
      const isTypeOk = this.accept.includes(fileExt);
      if (!isTypeOk) {
        this.$modal.msgError(`文件格式不正确, 请上传${this.accept}格式文件!`);
        return false;
      }
    },
    handleExceed() {
      this.$modal.msgError(`上传文件数量不能超过 ${this.limit} 个!`);
    },
    handleFile(data) {
      this.$modal.loading();
      let form = new FormData();
      form.append("file", data.file);
      importTbcz(form)
        .then((res) => {
          this.fileOpen = false;
          this.$modal.closeLoading();
          this.$modal.msgSuccess("导入成功");
          this.$refs.upload.clearFiles();
          this.getList();
        })
        .catch(() => {
          this.fileOpen = false;
          this.$modal.closeLoading();
          this.$refs.upload.clearFiles();
          this.getList();
        });
    },
    //批量启用
    enable(row) {
      this.isStatusFuc(row, 1);
    },
    //批量禁用
    banned(row) {
      this.isStatusFuc(row, 2);
    },
    isStatusFuc(row, e) {
      const ids = row.id || this.ids.join(",");
      const src = e == 1 ? "启动" : "禁用";
      this.$confirm("是否确认" + src + '编号为"' + ids + '"的数据项?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(function () {
          return isStatusTbcz({ ids: ids, isStatus: e });
        })
        .then(() => {
          this.getList(e);
        })
        .catch(() => {});
    },
    //添加表格
    addFile() {
      if (this.fileNameS.length <= 0) {
        this.fileNameS.push({
          fileName: "",
          fileUrl: "",
        });
      } else {
        if (
          this.fileNameS[this.fileNameS.length - 1].fileUrl != "" &&
          this.fileNameS[this.fileNameS.length - 1].fileName != ""
        ) {
          this.fileNameS.push({
            fileName: "",
            fileUrl: "",
          });
        } else {
          this.$modal.msgError("请完整填写上一条");
        }
      }
    },
    //删除表格
    removeFile(index) {
      this.fileNameS.splice(index, 1);
    },
    /** 查询通报处置列表 */
    getList(e) {
      this.loading = true;
      this.queryParams.params = {};
      if (null != this.daterangeCreateTime && "" != this.daterangeCreateTime) {
        this.queryParams.params["beginCreateTime"] =
          this.daterangeCreateTime[0];
        this.queryParams.params["endCreateTime"] = this.daterangeCreateTime[1];
      }
      if (null != this.daterangeUpdateTime && "" != this.daterangeUpdateTime) {
        this.queryParams.params["beginUpdateTime"] =
          this.daterangeUpdateTime[0];
        this.queryParams.params["endUpdateTime"] = this.daterangeUpdateTime[1];
      }
      listTbcz(this.queryParams).then((response) => {
        this.tbczList = response.rows;
        this.total = response.total;
        this.loading = false;
        if (e == 1) {
          this.$modal.msgSuccess("启动成功");
        } else if (e == 2) {
          this.$modal.msgSuccess("禁用成功");
        }
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,

        // areaId: null,

        isStatus: 1,

        unitName: null,

        ipAddress: null,

        czState: null,

        fileName: null,

        fileUrl: null,

        createBy: null,

        createTime: null,

        updateBy: null,

        updateTime: null,

        remark: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.daterangeCreateTime = [];
      this.daterangeUpdateTime = [];
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /**查看按钮操作 */
    handleInfo(row) {
      this.reset();
      const id = row.id || this.ids;
      getTbcz(id).then((response) => {
        this.form = response.data;
        this.infoOpen = true;
        this.infoTitle = "查看通报处置详情";
      });
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.fileNameS = [
        {
          fileName: "",
          fileUrl: "",
        },
      ];
      this.open = true;
      this.title = "添加通报处置";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      this.fileNameS = [];
      const id = row.id || this.ids;
      getTbcz(id).then((response) => {
        this.form = response.data;
        if (response.data.fileName && response.data.fileUrl) {
          let arr1 = response.data.fileName.split(",");
          let arr2 = response.data.fileUrl.split(",");
          arr1.forEach((value, index) => {
            this.fileNameS.push({
              fileName: value,
              fileUrl: arr2[index],
            });
          });
        }
        this.open = true;
        this.title = "修改通报处置";
      });
    },
    /** 提交按钮 */
    submitForm() {
      let arr1 = [];
      let arr2 = [];
      if (this.fileNameS.length > 0) {
        this.fileNameS.forEach((value) => {
          if (value.fileName && value.fileUrl) {
            arr1.push(value.fileName);
            arr2.push(value.fileUrl);
          }
        });
        this.form.fileName = arr1.join(",");
        this.form.fileUrl = arr2.join(",");
      } else {
        this.form.fileName = "";
        this.form.fileUrl = "";
      }
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.form.id != null) {
            updateTbcz(this.form).then((response) => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addTbcz(this.form).then((response) => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除编号为"' + ids + '"的数据项?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(function () {
          return delTbcz(ids);
        })
        .then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm("是否确认导出所有通报处置数据项?", "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(() => {
          this.download(
            "/tcZz/networkSecurity/tbcz/export",
            {
              ...this.queryParams,
            },
            "通报处置_" + new Date().getTime() + ".xlsx"
          );
          this.exportLoading = false;
        })
        .catch(() => {});
    },
  },
};
</script>
<style lang="scss" scoped>
.updataFile {
  display: flex;
}
.fileIcon {
  width: 10%;
  display: flex;
  align-items: center;
  justify-content: center;
  font-size: 24px;
  cursor: pointer;
}
.main-file {
  display: flex;
}
.fileHeader {
  border: 1px solid #dcdfe6;
  color: #515a6e;
  font-weight: bold;
  height: 40px;
  display: flex;
  background: #f8f8f9;
  width: 90%;
}
.fileItems {
  border: 1px solid #dcdfe6;
  border-top: none;
  color: #606266;
  height: 40px;
  display: flex;
  width: 90%;
}
.names {
  width: 40%;
  border-right: 1px solid #dcdfe6;
  box-sizing: border-box;
  padding-left: 10px;
}
::v-deep .names .el-input__inner {
  border: none !important;
  padding-left: 0 !important;
}
.urls {
  width: 60%;
  box-sizing: border-box;
  padding-left: 10px;
}
::v-deep .urls .el-input__inner {
  border: none !important;
  padding-left: 0 !important;
}
</style>
